<template>
  <div>
    <div
      class="d-flex flex-column align-items-center justify-content-center min-vh100 p-2"
    >
      <img
        alt="Citadel"
        src="@/assets/logo.svg"
        height="200"
        class="mb-2 logo"
      />
      <h1 class="text-center mb-2">{{ heading }}</h1>
      <p class="text-muted w-75 text-center">{{ text }}</p>

      <div
        class="form-container mt-3 d-flex flex-column form-container w-100 align-items-center"
      >
        <div v-show="currentStep === 2">
          <seed
            v-show="userStore.seed.length && !isRegistering"
            :words="userStore.seed"
            :recover="recover"
            @complete="finishedSeed"
            @incomplete="incompleteRecoverySeed"
            @input="inputRecoverySeed"
          ></seed>
          <b-spinner
            v-show="!userStore.seed.length || isRegistering"
          ></b-spinner>
        </div>

        <div v-show="currentStep === 3">
          <div class="text-center bg-white p-3 rounded">
            <small class="d-block text-muted text-small text-center mb-3"
              >By clicking next, I agree that:</small
            >
            <span class="d-block text-muted text-small mb-1">
              <b-icon-exclamation-circle-fill variant="warning" class="me-1" />
              The version of Citadel built into Nirvati is currently a technical
              preview and will be changed significantly during the beta.
            </span>
            <span class="d-block text-muted text-small mb-1">
              <b-icon-exclamation-circle-fill variant="warning" class="me-1" />
              The Nirvati and Citadel developers are not responsible for any
              loss of funds or other damages caused by the use of this software.
            </span>
          </div>
        </div>

        <div v-show="currentStep === 3" class="text-center">
          <p class="text-muted">
            But you don't have to wait for the sync to complete... You can start
            using Citadel right away!
          </p>
          <a
            v-tooltip.bottom="
              'Citadel uses neutrino while the sync is in progress, and automatically switches to Bitcoin Core once it\'s synced'
            "
            href="#"
          >
            <small>
              <b-icon-exclamation-circle-fill
                icon="exclamation-circle-fill"
                variant="primary"
                class="me-1"
              />How?
            </small>
          </a>
        </div>

        <b-button
          variant="success"
          size="lg"
          :disabled="
            !isStepValid || isRegistering || !lightningStore.operational
          "
          class="mt-3 mx-auto d-block px-4"
          :class="{
            'loading-fade-blink':
              !lightningStore.operational ||
              (currentStep === 3 && !lightningStore.unlocked),
            invisible: currentStep === 1 && recover && !isStepValid,
          }"
          @click="nextStep"
          >{{
            !lightningStore.operational ? "Loading" : nextButtonText
          }}</b-button
        >
        <b-button
          v-if="currentStep === 2"
          variant="link"
          size="sm"
          class="mt-2 mx-auto d-block"
          @click="recoverFromSeed"
          >Recover</b-button
        >
        <b-button
          v-if="currentStep > 0 && currentStep !== 4"
          variant="link"
          size="sm"
          class="mt-2 mx-auto d-block text-dark"
          @click="prevStep"
          >Back</b-button
        >
      </div>
      <b-progress
        :value="progress"
        height="1rem"
        class="onboarding-progress"
      ></b-progress>
    </div>
  </div>
</template>

<script lang="ts">
/* eslint-disable */
import {defineComponent} from 'vue';
import useSystemStore from '../store/system';
import useUserStore from '../store/user';
import useBitcoinStore from '../store/bitcoin';
import useLightningStore from '../store/lightning';
import useSdkStore from '../store/sdk';
import useToast from '../utils/toast';

import InputPassword from '../components/Utility/InputPassword.vue';
import Seed from '../components/Utility/Seed.vue';
import InputCopy from '../components/Utility/InputCopy.vue';
import {BIconExclamationCircleFill} from 'bootstrap-icons-vue';

export default defineComponent({
  components: {
    InputPassword,
    Seed,
    InputCopy,
    BIconExclamationCircleFill: BIconExclamationCircleFill as any,
  },
  setup() {
    const systemStore = useSystemStore();
    const userStore = useUserStore();
    const bitcoinStore = useBitcoinStore();
    const lightningStore = useLightningStore();
    const sdkStore = useSdkStore();
    const toast = useToast();
    const {t} = useI18n();

    return {
      sdkStore,
      userStore,
      systemStore,
      bitcoinStore,
      lightningStore,
      toast,
      t,
    };
  },
  data(): {
    currentStep: number;
    notedSeed: boolean;
    isRegistering: boolean;
    recover: boolean;
    recoverySeed: string[];
    lndUnlockInterval: undefined | number;
  } {
    return {
      currentStep: 0,
      notedSeed: false,
      isRegistering: false,
      recover: false,
      recoverySeed: [],
      lndUnlockInterval: undefined,
    };
  },
  computed: {
    heading(): string {
      if (this.currentStep === 1 && this.recover) {
        return 'recover your citadel';
      }
      return this.t(`setup.step-${this.currentStep + 1}.heading`);
    },
    text(): string {
      if (this.currentStep === 1 && this.recover) {
        return 'Enter your 24 secret words in the exact order to recover your Citadel.';
      }
      return this.t(`setup.step-${this.currentStep + 1}.text`);
    },
    nextButtonText(): string {
      if (this.currentStep === 0) {
        return 'Start';
      }
      if (this.currentStep === 4) {
        return 'Go to dashboard';
      }
      return 'Next';
    },
    isStepValid(): boolean {
      if (this.currentStep === 2) {
        return this.notedSeed;
      }

      if (this.currentStep === 4) {
        return this.lightningStore.unlocked;
      }

      return true;
    },
    progress(): number {
      return this.currentStep === 0
        ? 0
        : Math.round((this.currentStep * 100) / 4);
    },
  },
  async created() {
    //redirect to home if the user is already registered
    if (this.userStore.registered) {
      return this.$router.push('/');
    }

    // Wait for LND
    while (!this.lightningStore.operational) {
      await this.lightningStore.getStatus();
      await delay(1000);
    }

    //generate a new seed on load
    this.userStore.getSeed();
  },
  beforeUnmount() {
    window.clearInterval(this.lndUnlockInterval);
  },
  methods: {
    recoverFromSeed() {
      this.recover = true;
      this.currentStep++;
    },
    inputRecoverySeed(seed: string[]) {
      this.recoverySeed = seed;
    },
    async nextStep() {
      if (this.currentStep === 1) {
        this.recover = false;
      }

      //Register user and initialize wallet at the end
      if (this.currentStep === 2) {
        this.isRegistering = true;
        const seed = this.recover ? this.recoverySeed : this.userStore.seed;
        try {
          await this.sdkStore.citadel.lightning.wallet.init(seed);
        } catch (error) {
          this.isRegistering = false;
          if (error) {
            this.toast.error('Error', JSON.stringify(error));
          }
          //return;
        }

        this.isRegistering = false;
      }

      if (this.currentStep === 3) {
        this.lndUnlockInterval = window.setInterval(async () => {
          this.lightningStore.getStatus();
          if (this.lightningStore.unlocked) {
            return window.clearInterval(this.lndUnlockInterval);
          }
        }, 1000);
      }

      if (this.currentStep === 4) {
        return this.$router.push('/dashboard');
      }

      this.currentStep++;
    },
    prevStep() {
      if (this.currentStep === 3) {
        this.notedSeed = false;
      }

      this.currentStep -= - 1;
    },
    finishedSeed() {
      this.notedSeed = true;
    },
    incompleteRecoverySeed() {
      this.notedSeed = false;
    },
  },
});
</script>

<style lang="scss" scoped>
.logo {
  height: 20vh;
  max-height: 200px;
  width: auto;
}
.form-container {
  max-width: 500px;
}
.onboarding-progress {
  position: absolute;
  width: 100%;
  top: 0;
  left: 0;
  border-radius: 0;
  background: transparent;
}
.loading-fade-blink {
  animation: loadingFadeBlink 1s infinite linear;
}

@keyframes loadingFadeBlink {
  0%,
  100% {
    opacity: 0.6;
  }
  50% {
    opacity: 0.3;
  }
}
</style>
